libstdc++: std::ios_base Class Reference

libstdc++

std::ios_base Class Reference
I/O

`#include <ios_base.h>`

Inheritance diagram for std::ios_base:
[legend]

## Classes
class | failure

## Public Types
enum | event { erase_event , imbue_event , copyfmt_event }
typedef void(* | event_callback) (event __e, ios_base &__b, int __i)
typedef _Ios_Fmtflags | fmtflags
typedef _Ios_Iostate | iostate
typedef _Ios_Openmode | openmode
typedef _Ios_Seekdir | seekdir

## Public Member Functions
| ios_base (const ios_base &)=delete
virtual | ~ios_base ()
const locale & | _M_getloc () const
fmtflags | flags () const
fmtflags | flags (fmtflags __fmtfl)
locale | getloc () const
locale | imbue (const locale &__loc) throw ()
long & | iword (int __ix)
ios_base & | operator= (const ios_base &)=delete
streamsize | precision () const
streamsize | precision (streamsize __prec)
void *& | pword (int __ix)
void | register_callback (event_callback __fn, int __index)
fmtflags | setf (fmtflags __fmtfl)
fmtflags | setf (fmtflags __fmtfl, fmtflags __mask)
void | unsetf (fmtflags __mask)
streamsize | width () const
streamsize | width (streamsize __wide)

## Static Public Member Functions
static bool | sync_with_stdio (bool __sync=true)
static int | xalloc () throw ()

## Static Public Attributes
static const openmode | __noreplace
static const fmtflags | adjustfield
static const openmode | app
static const openmode | ate
static const iostate | badbit
static const fmtflags | basefield
static const seekdir | beg
static const openmode | binary
static const fmtflags | boolalpha
static const seekdir | cur
static const fmtflags | dec
static const seekdir | end
static const iostate | eofbit
static const iostate | failbit
static const fmtflags | fixed
static const fmtflags | floatfield
static const iostate | goodbit
static const fmtflags | hex
static const openmode | in
static const fmtflags | internal
static const fmtflags | left
static const fmtflags | oct
static const openmode | out
static const fmtflags | right
static const fmtflags | scientific
static const fmtflags | showbase
static const fmtflags | showpoint
static const fmtflags | showpos
static const fmtflags | skipws
static const openmode | trunc
static const fmtflags | unitbuf
static const fmtflags | uppercase

## Protected Types
enum | { _S_local_word_size }

## Protected Member Functions
void | _M_call_callbacks (event __ev) throw ()
void | _M_dispose_callbacks (void) throw ()
_Words & | _M_grow_words (int __index, bool __iword)
void | _M_init () throw ()
void | _M_move (ios_base &) noexcept
void | _M_swap (ios_base &__rhs) noexcept

## Protected Attributes
_Callback_list * | _M_callbacks
iostate | _M_exception
fmtflags | _M_flags
locale | _M_ios_locale
_Words | _M_local_word [_S_local_word_size]
streamsize | _M_precision
iostate | _M_streambuf_state
streamsize | _M_width
_Words * | _M_word
int | _M_word_size
_Words | _M_word_zero

## Detailed Description

The base of the I/O class hierarchy.

This class defines everything that can be defined about I/O that does not depend on the type of characters being input or output. Most people will only see `ios_base` when they need to specify the full name of the various I/O flags (e.g., the openmodes).

Definition at line 265 of file ios_base.h.

## Member Typedef Documentation

## ◆ event_callback

typedef void(* std::ios_base::event_callback) (event __e, ios_base &__b, int __i)

The type of an event callback function.

Parameters

  __e | One of the members of the event enum.
  __b | Reference to the ios_base object.
  __i | The integer provided when the callback was registered.

Event callbacks are user defined functions that get called during several ios_base and basic_ios functions, specifically imbue(), copyfmt(), and ~ios().

Definition at line 573 of file ios_base.h.

## ◆ fmtflags

typedef _Ios_Fmtflags std::ios_base::fmtflags

This is a bitmask type.

`_Ios_Fmtflags is` implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type fmtflags are:

- boolalpha
- dec
- fixed
- hex
- internal
- left
- oct
- right
- scientific
- showbase
- showpoint
- showpos
- skipws
- unitbuf
- uppercase
- adjustfield
- basefield
- floatfield

Definition at line 378 of file ios_base.h.

## ◆ iostate

typedef _Ios_Iostate std::ios_base::iostate

This is a bitmask type.

`_Ios_Iostate is` implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type iostate are:

- badbit
- eofbit
- failbit
- goodbit

Definition at line 453 of file ios_base.h.

## ◆ openmode

typedef _Ios_Openmode std::ios_base::openmode

This is a bitmask type.

`_Ios_Openmode is` implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type openmode are:

- app
- ate
- binary
- in
- out
- trunc

Definition at line 484 of file ios_base.h.

## ◆ seekdir

typedef _Ios_Seekdir std::ios_base::seekdir

This is an enumerated type.

`_Ios_Seekdir is` implementation-defined. Defined values of type seekdir are:

- beg
- cur, equivalent to `SEEK_CUR` in the C standard library.
- end, equivalent to `SEEK_END` in the C standard library.

Definition at line 523 of file ios_base.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum
| protected

Definition at line 648 of file ios_base.h.

## ◆ event

enum std::ios_base::event

The set of events that may be passed to an event callback.

erase_event is used during ~ios() and copyfmt(). imbue_event is used during imbue(). copyfmt_event is used during copyfmt().

Definition at line 556 of file ios_base.h.

## Constructor & Destructor Documentation

## ◆ ~ios_base()

virtual std::ios_base::~ios_base | ( |  | ) |
| virtual

Invokes each callback with erase_event. Destroys local storage.

Note that the ios_base object for the standard streams never gets destroyed. As a result, any callbacks registered with the standard streams will not get invoked with erase_event (unless copyfmt is used).

## Member Function Documentation

## ◆ _M_getloc()

const locale & std::ios_base::_M_getloc | ( |  | ) | const
| inline

Locale access.

Returns
  A reference to the current locale.

Like getloc above, but returns a reference instead of generating a copy.

Definition at line 852 of file ios_base.h.

Referenced by std::money_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_date(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_time(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::num_put< _CharT, _OutIter >::do_put(), std::time_put< _CharT, _OutIter >::do_put(), std::time_get< _CharT, _InIter >::get(), and std::time_put< _CharT, _OutIter >::put().

## ◆ flags() [1/2]

fmtflags std::ios_base::flags | ( |  | ) | const
| inlinenodiscard

Access to format flags.

Returns
  The format control flags for both input and output.

Definition at line 694 of file ios_base.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt(), std::num_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), std::num_put< _CharT, _OutIter >::do_put(), std::chrono::operator<<(), std::philox_engine< uint_fast32_t, 32, 4, 10, 0xCD9E8D57, 0x9E3779B9, 0xD2511F53, 0xBB67AE85 >::operator<<, std::__detail::operator>>(), std::operator>>(), std::operator>>(), std::operator>>(), std::operator>>(), std::operator>>(), std::operator>>(), std::operator>>(), and std::philox_engine< uint_fast32_t, 32, 4, 10, 0xCD9E8D57, 0x9E3779B9, 0xD2511F53, 0xBB67AE85 >::operator>>.

## ◆ flags() [2/2]

fmtflags std::ios_base::flags | ( | fmtflags | __fmtfl | ) |
| inline

Setting new format flags all at once.

Parameters

  __fmtfl | The new flags to set.

Returns
  The previous format control flags.

This function overwrites all the format flags with __fmtfl.

Definition at line 705 of file ios_base.h.

## ◆ getloc()

locale std::ios_base::getloc | ( |  | ) | const
| inlinenodiscard

Locale access.

Returns
  A copy of the current locale.

If `imbue(loc)` has previously been called, then this function returns `loc`. Otherwise, it returns a copy of `std::locale()`, the global C++ locale.

Definition at line 841 of file ios_base.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt(), std::money_put< _CharT, _OutIter >::do_put(), std::basic_ios< _CharT, _Traits >::imbue(), std::chrono::operator<<(), std::operator>>(), std::operator>>(), and std::ws().

## ◆ imbue()

locale std::ios_base::imbue | ( | const locale & | __loc | ) |
throw | ( | ) |  |  |

Setting a new locale.

Parameters

  __loc | The new locale.

Returns
  The previous locale.

Sets the new locale for this stream, and then invokes each callback with imbue_event.

Referenced by std::basic_ios< _CharT, _Traits >::imbue().

## ◆ iword()

long & std::ios_base::iword | ( | int | __ix | ) |
| inline

Access to integer array.

Parameters

  __ix | Index into the array.

Returns
  A reference to an integer associated with the index.

The iword function provides access to an array of integers that can be used for any purpose. The array grows as required to hold the supplied index. All integers in the array are initialized to 0.

The implementation reserves several indices. You should use xalloc to obtain an index that is safe to use. Also note that since the array can grow dynamically, it is not safe to hold onto the reference.

Definition at line 887 of file ios_base.h.

References iword().

Referenced by iword().

## ◆ precision() [1/2]

streamsize std::ios_base::precision | ( |  | ) | const
| inlinenodiscard

Flags access.

Returns
  The precision to generate on certain output operations.

Be careful if you try to give a definition of precision here; see DR 189.

Definition at line 765 of file ios_base.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt(), and std::chrono::operator<<().

## ◆ precision() [2/2]

streamsize std::ios_base::precision | ( | streamsize | __prec | ) |
| inline

Changing flags.

Parameters

  __prec | The new precision value.

Returns
  The previous value of precision().

Definition at line 774 of file ios_base.h.

## ◆ pword()

void *& std::ios_base::pword | ( | int | __ix | ) |
| inline

Access to void pointer array.

Parameters

  __ix | Index into the array.

Returns
  A reference to a void* associated with the index.

The pword function provides access to an array of pointers that can be used for any purpose. The array grows as required to hold the supplied index. All pointers in the array are initialized to 0.

The implementation reserves several indices. You should use xalloc to obtain an index that is safe to use. Also note that since the array can grow dynamically, it is not safe to hold onto the reference.

Definition at line 908 of file ios_base.h.

## ◆ register_callback()

void std::ios_base::register_callback | ( | event_callback | __fn,
|  | int | __index )

Add the callback __fn with parameter __index.

Parameters

  __fn | The function to add.
  __index | The integer to pass to the function when invoked.

Registers a function as an event callback with an integer parameter to be passed to the function when invoked. Multiple copies of the function are allowed. If there are multiple callbacks, they are invoked in the order they were registered.

## ◆ setf() [1/2]

fmtflags std::ios_base::setf | ( | fmtflags | __fmtfl | ) |
| inline

Setting new format flags.

Parameters

  __fmtfl | Additional flags to set.

Returns
  The previous format control flags.

This function sets additional flags in format control. Flags that were previously set remain set.

Definition at line 721 of file ios_base.h.

Referenced by std::__detail::operator>>().

## ◆ setf() [2/2]

fmtflags std::ios_base::setf | ( | fmtflags | __fmtfl,
|  | fmtflags | __mask )
| inline

Setting new format flags.

Parameters

  __fmtfl | Additional flags to set.
  __mask | The flags mask for fmtfl.

Returns
  The previous format control flags.

This function clears mask in the format flags, then sets fmtfl `&` mask. An example mask is `ios_base::adjustfield`.

Definition at line 738 of file ios_base.h.

## ◆ sync_with_stdio()

bool std::ios_base::sync_with_stdio | ( | bool | __sync = true | ) |
| static

Interaction with the standard C I/O objects.

Parameters

  __sync | Whether to synchronize or not.

Returns
  True if the standard streams were previously synchronized.

The synchronization referred to is only that between the standard C facilities (e.g., stdout) and the standard C++ objects (e.g., cout). User-declared streams are unaffected. See https://gcc.gnu.org/onlinedocs/libstdc++/manual/fstreams.html#std.io.filestreams.binary

## ◆ unsetf()

void std::ios_base::unsetf | ( | fmtflags | __mask | ) |
| inline

Clearing format flags.

Parameters

  __mask | The flags to unset.

This function clears __mask in the format flags.

Definition at line 753 of file ios_base.h.

## ◆ width() [1/2]

streamsize std::ios_base::width | ( |  | ) | const
| inlinenodiscard

Flags access.

Returns
  The minimum field width to generate on output operations.

Minimum field width refers to the number of characters.

Definition at line 789 of file ios_base.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt(), std::num_put< _CharT, _OutIter >::do_put(), std::operator>>(), and std::operator>>().

## ◆ width() [2/2]

streamsize std::ios_base::width | ( | streamsize | __wide | ) |
| inline

Changing flags.

Parameters

  __wide | The new width value.

Returns
  The previous value of width().

Definition at line 798 of file ios_base.h.

## ◆ xalloc()

int std::ios_base::xalloc | ( |  | ) |
throw | ( | ) |  |  |
| static

Access to unique indices.

Returns
  An integer different from all previous calls.

This function returns a unique integer every time it is called. It can be used for any purpose, but is primarily intended to be a unique index for the iword and pword functions. The expectation is that an application calls xalloc in order to obtain an index in the iword and pword arrays that can be used without fear of conflict.

The implementation maintains a static variable that is incremented and returned on each invocation. xalloc is guaranteed to return an index that is safe to use in the iword and pword arrays.

## Member Data Documentation

## ◆ __noreplace

const openmode std::ios_base::__noreplace
| static

Definition at line 506 of file ios_base.h.

## ◆ _M_callbacks

_Callback_list* std::ios_base::_M_callbacks
| protected

Definition at line 627 of file ios_base.h.

## ◆ _M_exception

iostate std::ios_base::_M_exception
| protected

Definition at line 592 of file ios_base.h.

## ◆ _M_flags

fmtflags std::ios_base::_M_flags
| protected

Definition at line 591 of file ios_base.h.

## ◆ _M_ios_locale

locale std::ios_base::_M_ios_locale
| protected

Definition at line 659 of file ios_base.h.

## ◆ _M_local_word

_Words std::ios_base::_M_local_word[_S_local_word_size]
| protected

Definition at line 649 of file ios_base.h.

## ◆ _M_precision

streamsize std::ios_base::_M_precision
| protected

Definition at line 589 of file ios_base.h.

## ◆ _M_streambuf_state

iostate std::ios_base::_M_streambuf_state
| protected

Definition at line 593 of file ios_base.h.

## ◆ _M_width

streamsize std::ios_base::_M_width
| protected

Definition at line 590 of file ios_base.h.

## ◆ _M_word

_Words* std::ios_base::_M_word
| protected

Definition at line 653 of file ios_base.h.

## ◆ _M_word_size

int std::ios_base::_M_word_size
| protected

Definition at line 652 of file ios_base.h.

## ◆ _M_word_zero

_Words std::ios_base::_M_word_zero
| protected

Definition at line 644 of file ios_base.h.

## ◆ adjustfield

const fmtflags std::ios_base::adjustfield
| static

A mask of left|right|internal. Useful for the 2-arg form of `setf`.

Definition at line 433 of file ios_base.h.

Referenced by std::num_put< _CharT, _OutIter >::do_put(), std::internal(), std::left(), and std::right().

## ◆ app

const openmode std::ios_base::app
| static

Seek to end before each write.

Definition at line 487 of file ios_base.h.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_set_buffer(), std::basic_filebuf< _CharT, _Traits >::overflow(), and std::basic_filebuf< _CharT, _Traits >::xsputn().

## ◆ ate

const openmode std::ios_base::ate
| static

Open and seek to end immediately after opening.

Definition at line 490 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::open().

## ◆ badbit

const iostate std::ios_base::badbit
| static

Indicates a loss of integrity in an input or output sequence (such as an irrecoverable read error from a file).

Definition at line 457 of file ios_base.h.

Referenced by std::basic_istream< _CharT, _Traits >::sentry::sentry(), std::basic_ostream< _CharT, _Traits >::sentry::~sentry(), std::basic_ios< _CharT, _Traits >::clear(), std::basic_ostream< _CharT, _Traits >::flush(), std::basic_iostream< char_type, traits_type >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_iostream< char_type, traits_type >::operator<<(), std::basic_ostream< _CharT, _Traits >::operator<<(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_ostream< _CharT, _Traits >::put(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, char_traits< _CharT > >::read(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::sync(), std::basic_istream< _CharT, _Traits >::tellg(), std::basic_istream< _CharT, _Traits >::unget(), and std::ws().

## ◆ basefield

const fmtflags std::ios_base::basefield
| static

A mask of dec|oct|hex. Useful for the 2-arg form of `setf`.

Definition at line 436 of file ios_base.h.

Referenced by std::dec(), std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), std::hex(), and std::oct().

## ◆ beg

const seekdir std::ios_base::beg
| static

Request a seek relative to the beginning of the stream.

Definition at line 526 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::seekpos().

## ◆ binary

const openmode std::ios_base::binary
| static

Perform input and output in binary mode (as opposed to text mode). This is probably not what you think it is; see https://gcc.gnu.org/onlinedocs/libstdc++/manual/fstreams.html#std.io.filestreams.binary.

Definition at line 495 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::showmanyc().

## ◆ boolalpha

const fmtflags std::ios_base::boolalpha
| static

Insert/extract `bool` in alphabetic rather than numeric format.

Definition at line 381 of file ios_base.h.

Referenced by std::boolalpha(), std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), and std::noboolalpha().

## ◆ cur

const seekdir std::ios_base::cur
| static

Request a seek relative to the current position within the sequence.

Definition at line 529 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::imbue(), std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_filebuf< _CharT, _Traits >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_istream< _CharT, _Traits >::tellg(), and std::basic_ostream< _CharT, _Traits >::tellp().

## ◆ dec

const fmtflags std::ios_base::dec
| static

Converts integer input or generates integer output in decimal base.

Definition at line 384 of file ios_base.h.

Referenced by std::dec(), std::philox_engine< uint_fast32_t, 32, 4, 10, 0xCD9E8D57, 0x9E3779B9, 0xD2511F53, 0xBB67AE85 >::operator<<, and std::philox_engine< uint_fast32_t, 32, 4, 10, 0xCD9E8D57, 0x9E3779B9, 0xD2511F53, 0xBB67AE85 >::operator>>.

## ◆ end

const seekdir std::ios_base::end
| static

Request a seek relative to the current end of the sequence.

Definition at line 532 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::open(), and std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff().

## ◆ eofbit

const iostate std::ios_base::eofbit
| static

Indicates that an input operation reached the end of an input sequence.

Definition at line 460 of file ios_base.h.

Referenced by std::num_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_date(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_time(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::time_get< _CharT, _InIter >::get(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_istream< _CharT, char_traits< _CharT > >::peek(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, char_traits< _CharT > >::seekg(), std::basic_istream< _CharT, _Traits >::unget(), std::basic_istream< _CharT, char_traits< _CharT > >::unget(), and std::ws().

## ◆ failbit

const iostate std::ios_base::failbit
| static

Indicates that an input operation failed to read the expected characters, or that an output operation failed to generate the desired characters.

Definition at line 465 of file ios_base.h.

Referenced by std::basic_ostream< _CharT, _Traits >::sentry::sentry(), std::basic_fstream< char >::close(), std::basic_ifstream< char >::close(), std::basic_ofstream< char >::close(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::time_get< _CharT, _InIter >::get(), std::basic_fstream< char >::open(), std::basic_fstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_ofstream< char >::open(), std::basic_ofstream< char >::open(), std::operator<<(), std::basic_iostream< char_type, traits_type >::operator>>(), std::basic_istream< _CharT, _Traits >::operator>>(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ostream< _CharT, _Traits >::seekp(), and std::basic_ostream< _CharT, _Traits >::seekp().

## ◆ fixed

const fmtflags std::ios_base::fixed
| static

Generate floating-point output in fixed-point notation.

Definition at line 387 of file ios_base.h.

Referenced by std::fixed(), and std::hexfloat().

## ◆ floatfield

const fmtflags std::ios_base::floatfield
| static

A mask of scientific|fixed. Useful for the 2-arg form of `setf`.

Definition at line 439 of file ios_base.h.

Referenced by std::defaultfloat(), std::fixed(), std::hexfloat(), and std::scientific().

## ◆ goodbit

const iostate std::ios_base::goodbit
| static

Indicates all is well.

Definition at line 468 of file ios_base.h.

Referenced by std::basic_istream< _CharT, _Traits >::sentry::sentry(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::basic_ostream< _CharT, _Traits >::flush(), std::basic_iostream< char_type, traits_type >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::time_get< _CharT, _InIter >::get(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_iostream< char_type, traits_type >::operator<<(), std::basic_ostream< _CharT, _Traits >::operator<<(), std::basic_iostream< char_type, traits_type >::operator>>(), std::basic_istream< _CharT, _Traits >::operator>>(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_istream< _CharT, _Traits >::peek(), std::basic_ostream< _CharT, _Traits >::put(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::sync(), std::basic_istream< _CharT, _Traits >::unget(), and std::ws().

## ◆ hex

const fmtflags std::ios_base::hex
| static

Converts integer input or generates integer output in hexadecimal base.

Definition at line 390 of file ios_base.h.

Referenced by std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), and std::hex().

## ◆ in

const openmode std::ios_base::in
| static

Open for input. Default for `ifstream` and fstream.

Definition at line 498 of file ios_base.h.

Referenced by std::basic_fstream< char >::basic_fstream(), std::basic_fstream< char >::basic_fstream(), std::basic_fstream< char >::basic_fstream(), std::basic_ifstream< char >::basic_ifstream(), std::basic_ifstream< char >::basic_ifstream(), std::basic_ifstream< char >::basic_ifstream(), std::basic_istringstream< char >::basic_istringstream(), std::basic_stringbuf< char >::basic_stringbuf(), std::basic_stringstream< char >::basic_stringstream(), std::basic_filebuf< char_type, traits_type >::_M_set_buffer(), std::basic_fstream< char >::open(), std::basic_fstream< char >::open(), std::basic_fstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_streambuf< char_type, traits_type >::pubseekoff(), std::basic_streambuf< char_type, traits_type >::pubseekpos(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_streambuf< char_type, traits_type >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< char >::seekoff(), std::basic_streambuf< char_type, traits_type >::seekpos(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_stringbuf< char >::seekpos(), std::basic_filebuf< _CharT, _Traits >::showmanyc(), std::basic_stringbuf< char >::showmanyc(), std::basic_istream< _CharT, _Traits >::tellg(), std::basic_filebuf< _CharT, _Traits >::underflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::underflow(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

## ◆ internal

const fmtflags std::ios_base::internal
| static

Adds fill characters at a designated internal point in certain generated output, or identical to `right` if no such point is designated.

Definition at line 395 of file ios_base.h.

Referenced by std::internal().

## ◆ left

const fmtflags std::ios_base::left
| static

Adds fill characters on the right (final positions) of certain generated output. (I.e., the thing you print is flush left.).

Definition at line 399 of file ios_base.h.

Referenced by std::num_put< _CharT, _OutIter >::do_put(), std::left(), and std::philox_engine< uint_fast32_t, 32, 4, 10, 0xCD9E8D57, 0x9E3779B9, 0xD2511F53, 0xBB67AE85 >::operator<<.

## ◆ oct

const fmtflags std::ios_base::oct
| static

Converts integer input or generates integer output in octal base.

Definition at line 402 of file ios_base.h.

Referenced by std::oct().

## ◆ out

const openmode std::ios_base::out
| static

Open for output. Default for `ofstream` and fstream.

Definition at line 501 of file ios_base.h.

Referenced by std::basic_fstream< char >::basic_fstream(), std::basic_fstream< char >::basic_fstream(), std::basic_fstream< char >::basic_fstream(), std::basic_ofstream< char >::basic_ofstream(), std::basic_ofstream< char >::basic_ofstream(), std::basic_ofstream< char >::basic_ofstream(), std::basic_ostringstream< char >::basic_ostringstream(), std::basic_stringbuf< char >::basic_stringbuf(), std::basic_stringstream< char >::basic_stringstream(), std::basic_filebuf< char_type, traits_type >::_M_set_buffer(), std::basic_fstream< char >::open(), std::basic_fstream< char >::open(), std::basic_fstream< char >::open(), std::basic_ofstream< char >::open(), std::basic_ofstream< char >::open(), std::basic_ofstream< char >::open(), std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::pbackfail(), std::basic_streambuf< char_type, traits_type >::pubseekoff(), std::basic_streambuf< char_type, traits_type >::pubseekpos(), std::basic_streambuf< char_type, traits_type >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< char >::seekoff(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_streambuf< char_type, traits_type >::seekpos(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_stringbuf< char >::seekpos(), std::basic_ostream< _CharT, _Traits >::tellp(), and std::basic_filebuf< _CharT, _Traits >::xsputn().

## ◆ right

const fmtflags std::ios_base::right
| static

Adds fill characters on the left (initial positions) of certain generated output. (I.e., the thing you print is flush right.).

Definition at line 406 of file ios_base.h.

Referenced by std::right().

## ◆ scientific

const fmtflags std::ios_base::scientific
| static

Generates floating-point output in scientific notation.

Definition at line 409 of file ios_base.h.

Referenced by std::hexfloat(), and std::scientific().

## ◆ showbase

const fmtflags std::ios_base::showbase
| static

Generates a prefix indicating the numeric base of generated integer output.

Definition at line 413 of file ios_base.h.

Referenced by std::num_put< _CharT, _OutIter >::do_put(), std::noshowbase(), and std::showbase().

## ◆ showpoint

const fmtflags std::ios_base::showpoint
| static

Generates a decimal-point character unconditionally in generated floating-point output.

Definition at line 417 of file ios_base.h.

Referenced by std::noshowpoint(), and std::showpoint().

## ◆ showpos

const fmtflags std::ios_base::showpos
| static

Generates a + sign in non-negative generated numeric output.

Definition at line 420 of file ios_base.h.

Referenced by std::noshowpos(), and std::showpos().

## ◆ skipws

const fmtflags std::ios_base::skipws
| static

Skips leading white space before certain input operations.

Definition at line 423 of file ios_base.h.

Referenced by std::noskipws(), std::__detail::operator>>(), std::philox_engine< uint_fast32_t, 32, 4, 10, 0xCD9E8D57, 0x9E3779B9, 0xD2511F53, 0xBB67AE85 >::operator>>, and std::skipws().

## ◆ trunc

const openmode std::ios_base::trunc
| static

Truncate an existing stream when opening. Default for `ofstream`.

Definition at line 504 of file ios_base.h.

## ◆ unitbuf

const fmtflags std::ios_base::unitbuf
| static

Flushes output after each output operation.

Definition at line 426 of file ios_base.h.

Referenced by std::basic_ostream< _CharT, _Traits >::sentry::~sentry(), std::nounitbuf(), and std::unitbuf().

## ◆ uppercase

const fmtflags std::ios_base::uppercase
| static

Replaces certain lowercase letters with their uppercase equivalents in generated output.

Definition at line 430 of file ios_base.h.

Referenced by std::num_put< _CharT, _OutIter >::do_put(), std::nouppercase(), and std::uppercase().

The documentation for this class was generated from the following file:

- ios_base.h